--- playdv/display.c.orig	Mon Jun 25 01:06:52 2001
+++ playdv/display.c	Sat Aug 18 05:31:26 2001
@@ -54,6 +54,12 @@
 static void dv_center_window(SDL_Surface *screen);
 #endif
 
+
+#ifdef __FreeBSD__
+static dv_display_t *display = NULL;
+#endif /* __FreeBSD__ */
+
+
 #if HAVE_LIBXV
 
 #define XV_FORMAT_MASK		0x03
@@ -257,6 +263,9 @@
   } /* switch */
 
   free(dv_dpy);
+#ifdef __FreeBSD__
+  display = NULL;
+#endif
 } /* dv_display_exit */
 
 static gboolean
@@ -675,6 +684,12 @@
   } /* if */
 } /* dv_display_exit_handler */
 
+static void
+dv_display_exit_handler_FreeBSD(void)
+{
+  dv_display_exit_handler(display != NULL, display);
+} /* dv_display_exit_handler_FreeBSD */
+
 
 gboolean
 dv_display_init(dv_display_t *dv_dpy, gint *argc, gchar ***argv, gint width, gint height, 
@@ -804,7 +819,12 @@
   fprintf(stderr, " Using gtk for display\n");
 
  ok:
+#ifdef __FreeBSD__
+  display = dv_dpy;
+  atexit(dv_display_exit_handler_FreeBSD);
+#else /* !__FreeBSD__ */
   on_exit(dv_display_exit_handler, dv_dpy);
+#endif
   return(TRUE);
 
  fail:
